#ifndef INCLUDE_sql_h__
#define INCLUDE_sql_h__

#include <dbi/dbi.h>
#include <stdarg.h>
#define prefixcmp(a, b) strncmp(a, b, strlen(b))

extern char *host_perf_table;
extern char *service_perf_table;

typedef dbi_result SQL_RESULT;

extern int sql_config(const char *key, const char *value);
extern int sql_is_connected(void);
extern int sql_init(void);
extern int sql_close(void);
extern int sql_reinit(void);
extern size_t sql_quote(const char *src, char **dst);
extern int sql_error(const char **msg);
extern const char *sql_error_msg(void);
extern void sql_free_result(void);
extern int sql_query(const char *fmt, ...)
	__attribute__((__format__(__printf__, 1, 2)));
extern int sql_vquery(const char *fmt, va_list ap);
extern dbi_result sql_get_result(void);
extern const char *sql_table_name(void);
extern const char *sql_db_name(void);
extern const char *sql_db_user(void);
extern const char *sql_db_pass(void);
extern const char *sql_db_host(void);

#endif
